<template>
    <div
        v-if="setupReady"
    >
        <div
            v-for="(row, i) in computedFields"
            :key="`auto-form-${i}`"
        >
            <div
                v-if="row.type === 'text' || row.type === 'email' || row.type === 'number'"
                class="mb-4"
            >
                <component
                    :is="FormInput"
                    v-bind="row"
                    :model-value="formData.get(row.name) || ''"
                    :errors="errors[row.name]"
                    @update:model-value="newValue => rowChanged(newValue, row)"
                />
            </div>
            <div
                v-else-if="row.type === 'editor'"
                class="mb-4"
            >
                <component
                    :is="FormEditor"
                    v-bind="row"
                    :model-value="formData.get(row.name) || ''"
                    :errors="errors[row.name]"
                    @update:model-value="newValue => rowChanged(newValue, row)"
                />
            </div>
            <div
                v-else-if="row.type === 'time'"
                class="mb-4"
            >
                <component
                    :is="FormTime"
                    v-bind="row"
                    :model-value="formData.get(row.name) || ''"
                    :errors="errors[row.name]"
                    @update:model-value="newValue => rowChanged(newValue, row)"
                />
            </div>
            <div
                v-else-if="row.type === 'date'"
                class="mb-4"
            >
                <component
                    :is="FormDate"
                    v-bind="row"
                    :model-value="formData.get(row.name) || ''"
                    :errors="errors[row.name]"
                    @update:model-value="newValue => rowChanged(newValue, row)"
                />
            </div>
            <div
                v-else-if="row.type === 'textarea'"
                class="mb-4"
            >
                <component
                    :is="FormTextArea"
                    v-bind="row"
                    :model-value="formData.get(row.name) || ''"
                    :errors="errors[row.name]"
                    @update:model-value="newValue => rowChanged(newValue, row)"
                />
            </div>
            <div
                v-else-if="row.type === 'password'"
                class="mb-4"
            >
                <component
                    :is="FormPassword"
                    v-bind="row"
                    :model-value="formData.get(row.name) || ''"
                    :errors="errors[row.name]"
                    @update:model-value="newValue => rowChanged(newValue, row)"
                />
            </div>
            <div
                v-else-if="row.type === 'file'"
                class="mb-4"
            >
                <component
                    :is="FormFile"
                    v-bind="row"
                    :model-value="formData.get(row.name) || ''"
                    :errors="errors[row.name]"
                    @update:model-value="newValue => rowChanged(newValue, row)"
                />
            </div>
            <div
                v-else-if="row.type === 'select'"
                class="mb-4"
            >
                <component
                    :is="FormSelect"
                    v-bind="row"
                    :model-value="formData.get(row.name) || ''"
                    :errors="errors[row.name]"
                    @update:model-value="newValue => rowChanged(newValue, row)"
                />
            </div>
            <div
                v-else-if="row.type === 'checkbox'"
                class="mb-4"
            >
                <component
                    :is="FormCheckbox"
                    v-bind="row"
                    :model-value="row.multiple ? (formData.getAll(row.name) || []) : (formData.get(row.name) || '')"
                    :errors="errors[row.name]"
                    @update:model-value="newValue => rowChanged(newValue, row)"
                />
            </div>
            <div
                v-else-if="row.type === 'contact'"
                class="mb-4"
            >
                <component
                    :is="FormContact"
                    v-bind="row"
                    :select-value="formData.get(row.contactCountryName)"
                    :input-value="formData.get(row.contactNumberName)"
                    :errors="errors"
                    @update:select-value="newValue => rowChanged(newValue, row, 'select')"
                    @update:input-value="newValue => rowChanged(newValue, row, 'input')"
                />
            </div>
            <div
                v-else-if="row.type === 'pin'"
                class="mb-4"
            >
                <component
                    :is="FormPin"
                    v-bind="row"
                    :model-value="formData.get(row.name) || ''"
                    :errors="errors[row.name]"
                    @update:model-value="newValue => rowChanged(newValue, row)"
                />
            </div>
        </div>
        <teleport
            v-if="password2Prompt"
            to="body"
        >
            <div
                class="fixed top-0 left-0 right-0 bottom-0 w-screen h-screen bg-gray-700 bg-opacity-40 flex justify-center text-center items-center"
            >
                <div
                    class="w-[360px] bg-neutral rounded-lg p-4 mx-auto"
                >
                    <div
                        class="my-6 text-center mx-auto text-lg font-bold"
                    >
                        {{ computedPassword2VerifyTitle }}
                    </div>
                    <div
                        class="text-center mx-auto px-9 mb-4"
                    >
                        {{ computedPassword2VerifyMessage }}
                    </div>
                    <div>
                        <form-pin
                            name="current_password2"
                            :errors="errors.current_password2"
                            :model-value="password2"
                            :hide-label="true"
                            :dark="true"
                            size="lg"
                            @update:model-value="newValue => rowChanged(newValue, {type: 'pin', name: 'current_password2'})"
                        />
                    </div>
                    <div class="mt-6 text-2xl uppercase">
                        <auto-button
                            :busy="busy"
                            :rounded="false"
                            @click="submitForm"
                        >
                            {{ $t('confirm') }}
                        </auto-button>
                    </div>
                    <div class="mt-4 mb-6 text-xl capitalize">
                        <a
                            href="javascript:"
                            class="underline"
                            @click="password2Prompt = false"
                        >
                            {{ $t('close') }}
                        </a>
                    </div>
                </div>
            </div>
        </teleport>
    </div>
</template>

<script setup>
import {computed, inject, nextTick, onMounted, ref} from "vue";
import axios from "axios";
import FormDate from './form/form-datepicker.vue';
import FormTime from './form/form-timepicker.vue';
import FormTextarea from './form/form-textarea.vue';
import FormEditor from './form/form-editor.vue';
import FormInput from './form/form-input.vue';
import FormPassword from './form/form-password.vue';
import FormFile from './form/form-file.vue';
import FormSelect from './form/form-select.vue';
import FormCheckbox from './form/form-checkbox.vue';
import FormContact from './form/form-contact.vue';
import FormTextArea from './form/form-textarea.vue';
import FormPin from './form/form-pin.vue';
import {useI18n} from "vue-i18n";
import AutoButton from "!/admin/components/button/auto-button.vue";
const props = defineProps({
    fields: {
        required: true,
        type: Array,
    },
    defaultData: {
        required: false,
        type: Object,
        default: () => {
            return {};
        },
    },
    hiddenData: {
        required: false,
        type: Object,
        default: () => {
            return {};
        },
    },
    password2Verify: {
        required: false,
        type: Boolean,
        default: false
    },
    password2VerifyTitle: {
        required: false,
        type: String,
        default: 'default',
    },
    password2VerifyMessage: {
        required: false,
        type: String,
        default: 'default',
    }
});

const emit = defineEmits(['form-update']);
const $helper = inject('$helper');
const i18n = useI18n();

const setupReady = ref(false);
const formData = new FormData();
const errors = ref({});
const busy = ref(false);
const password2 = ref('');
const password2Prompt = ref(false);
const submitFormUrl = ref('');
const callbackFunction = ref(null);

const computedPassword2VerifyTitle = computed(() => {
    return props.password2VerifyTitle === 'default' ? i18n.t('password2_verify_default_title') : props.password2VerifyTitle;
});
const computedPassword2VerifyMessage = computed(() => {
    return props.password2VerifyMessage === 'default' ? i18n.t('password2_verify_default_message') : props.password2VerifyMessage;
});

const computedFields = computed(() => {
    return props.fields.map(r => {
        if (r.type === 'contact') {
            return {
                ...r,
                contactCountryName: r.contactCountryName ?? 'contact_country_id',
                contactNumberName: r.contactNumberName ?? 'contact_number',
            }
        } else {
            return r;
        }
    });
});

const getFormData = () => {
    return formData;
};

const rowChanged = (newValue, row, contactField) => {
    if (row.type === 'editor') {
        formData.set(row.name, JSON.stringify(newValue));
    } else if (row.type === 'file') {
        if (newValue instanceof File) {
            formData.set(row.name, newValue);
        } else if (newValue instanceof FileList) {
            [...newValue].forEach(file => {
                formData.append(row.name, file);
            });
        } else {
            formData.delete(row.name);
        }
    } else if (row.type === 'contact') {
        if (contactField === 'select') {
            formData.set(row.contactCountryName, String(newValue));
        } else if (contactField === 'input') {
            formData.set(row.contactNumberName, String(newValue));
        }
    } else {
        if (Array.isArray(newValue)) {
            formData.delete(row.name);
            newValue.forEach(r => {
                formData.append(row.name, r);
            });
        } else {
            formData.set(row.name, String(newValue));
        }
    }

    //CLEAR ERROR
    if (row.type === 'contact') {
        if (contactField === 'select') {
            errors.value[row.contactCountryName] = [];
        } else if (contactField === 'input') {
            errors.value[row.contactNumberName] = [];
        }
    } else {
        errors.value[row.name] = [];
    }

    if (props.password2Verify && row.name === 'current_password2') {
        password2.value = newValue;
        formData.set('current_password2', newValue);
    }

    emit('form-update', formData);
};

const submitForm = async (url, callback) => {
    try {
        if (props.password2Verify && !password2Prompt.value) {
            submitFormUrl.value = url;
            callbackFunction.value = callback;

            password2Prompt.value = true;
            return Promise.resolve('prompt');
        } else {
            busy.value = true;

            const resp = await axios.post(url || submitFormUrl.value, formData);

            if (props.password2Verify) password2Prompt.value = false;

            if (typeof callback === 'function') {
                callback(resp);
            } else if (typeof callbackFunction.value === 'function') {
                callbackFunction.value(resp);
            }

            return Promise.resolve(resp);
        }
    } catch (error) {
        if (typeof error.response.data.errors !== 'undefined') {
            errors.value = error.response.data.errors;

            if (props.password2Verify && password2Prompt && typeof error.response.data.errors.current_password2 === 'undefined') {
                password2Prompt.value = false;
            }
        } else if (error.response) {
            // Request made and server responded
            console.log(error.response.data);
            console.log(error.response.status);
            console.log(error.response.headers);
        } else if (error.request) {
            // The request was made but no response was received
            console.log(error.request);
        } else {
            console.log(error);
            await $helper.alertError({message: error.message});
        }

        return Promise.reject(error);
    } finally {
        busy.value = false;
    }
};

const setValue = (payload => {
    formData.set(payload.name, payload.value);
});

const setErrors = (payload => {
    errors.value = payload;
});

onMounted(async () => {
    await nextTick(async () => {
        computedFields.value.forEach(r => {
            if (r.type === 'contact') {
                formData.set(r.contactCountryName, props.defaultData[r.contactCountryName] || '');
                formData.set(r.contactNumberName, props.defaultData[r.contactNumberName] || '');
            } else if (r.type === 'checkbox' && r.multiple) {
                if (typeof props.defaultData[r.name] && Array.isArray(props.defaultData[r.name])) {
                    props.defaultData[r.name].forEach(dr => {
                        formData.append(r.name, String(dr));
                    });
                }
            } else if ((r.type === 'file' && !r.multiple) || r.type !== 'file') {
                formData.set(r.name, props.defaultData[r.name] || '');
            }
        });

        Object.keys(props.hiddenData).forEach(r => {
            formData.set(r, props.hiddenData[r]);
        });

        if (props.password2Verify) {
            formData.set('current_password2', '');
        }

        emit('form-update', formData);

        await nextTick(() => {
            setupReady.value = true;
        })
    });
});

defineExpose({
    FormDate,
    FormTime,
    FormInput,
    FormTextarea,
    FormEditor,
    FormPassword,
    FormFile,
    FormSelect,
    FormCheckbox,
    FormContact,
    FormTextArea,
    FormPin,
    computedFields,
    formData,
    busy,
    rowChanged,
    getFormData,
    setErrors,
    setValue,
    submitForm,
});
</script>
